package com.unitesk.requality.core;

public abstract class TreeChangeListener implements ITreeChangeListener {

    @Override
    public void changed(TreeNode node, boolean internal) {
        changed(node);
    }

    @Override
    public void created(TreeNode node, boolean internal) {
        created(node);
    }

    @Override
    public void deleted(NodeDesc node, boolean internal) {
        deleted(node);
    }

    @Override
    public void moved(TreeNode node, TreeNode oldParent, boolean internal) {
        moved(node, oldParent);
    }

    public abstract void changed(TreeNode node);

    public abstract void created(TreeNode node);

    public abstract void deleted(NodeDesc node);

    public abstract void moved(TreeNode node, TreeNode oldParent);

}
