package com.unitesk.requality.core.domproxy;

import org.dom4j.QName;
import org.dom4j.tree.AbstractAttribute;

import com.unitesk.requality.core.Attribute;
import com.unitesk.requality.core.AttributeType;
import com.unitesk.requality.core.TreeNode;

public class RequalityAttribute extends AbstractAttribute{
	/**
	 * 
	 */
	private static final long serialVersionUID = 6175753875563830373L;
	private Attribute a;
	private RequalityAttribute(Attribute a) {
		super();
		this.a = a;
	}
	public static RequalityAttribute getUUIDAttribute(TreeNode targ){
		return RequalityAttribute.toAttribute(new com.unitesk.requality.core.Attribute(targ, AttributeType.STRING, "uuid", targ.getUUId().toString()));
	}
	public static RequalityAttribute getIdAttribute(TreeNode targ){
		return RequalityAttribute.toAttribute(new com.unitesk.requality.core.Attribute(targ, AttributeType.STRING, "id", targ.getId()));
	}
	@Override
	public QName getQName() {
		return new QName(a.getKey());
	}
	public static RequalityAttribute toAttribute(Attribute a){
		if (a==null)
			return null;
		return new RequalityAttribute(a);
	}
	@Override
	public String getValue() {
		if(a.getValue()==null)
			return null;
		return a.getValue().toString();
	}
	public Attribute getWrappedAttribute() {
		return a;
	}
	public static RequalityAttribute getNameOrIdAttribute(TreeNode targ) {
		return RequalityAttribute.toAttribute(new com.unitesk.requality.core.Attribute(targ, AttributeType.STRING, "nameorid", targ.getNameOrId()));
	}
}
