package com.unitesk.requality.core.nodeiterators;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.UUID;

import org.apache.poi.hssf.record.DBCellRecord;

import com.unitesk.requality.core.Attribute;
import com.unitesk.requality.core.AttributeType;
import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeLogic;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.core.instancer.TreeInstancer;
import com.unitesk.requality.nodetypes.VirtualNode;

public class BaseReqChildIterator extends RequalityChildIterator {

	public BaseReqChildIterator(UUID guid, UUID mast, 
			String s){
		super(guid, mast, RequalityIteratorType.CHILD, s);
		chitype = RequalityChildIteratorType.BASEREQ;
		// TODO Auto-generated constructor stub
	}

	@Override
	public int getCount(TreeDB db) {
		return getInstancerMaster(db).getTarget().sizeRawChildren();
	}

	@Override
	public void updateChildren(TreeDB db) {
		if(getInstancerMaster(db).getTarget() == null)
			return;
		TreeInstancer ti = getInstancerMaster(db).getVirtualStorage();
		getInstancerMaster(db).getVirtualTreeDB().startChangeRow();
		List<UUID> ids = new ArrayList<UUID>( getInstancerMaster(db).getTarget().getRawChildrenUUIDs()),
					added = new ArrayList<UUID>();
		for(int i=0; i<getItemsCount(db); i++){
			String newId = getInstancerMaster(db).getTarget().getRawChild(i).getId();
			//if(getInstancerMaster().findChild(newId)!=null)
				//newId = getInstancerMaster().getTarget().getChild(i).getId()+"_"+i;
			added.add(ti.cloneUUID(ids.get(i), getInstancerMaster(db).getUUId(), newId));
		}
		
		List<UUID> uids = new ArrayList<UUID>(getInstancerMaster(db).getClones(true));
		int ccount = uids.size();
		for(int i = ccount-1; i >= 0; i--){
			UUID uid = uids.get(i);
			TreeNode node = getInstancerMaster(db).getVirtualTreeDB().getNode(uid);
			if(added.contains(uid)){
				node.putAttribute(new Attribute(getMasterUUId(), AttributeType.STRING, "__i", Integer.toString(i)));
				node.putAttribute(new Attribute(getMasterUUId(), AttributeType.STRING, "__I", Integer.toString(i+1)));
				node.saveAttributes();
				VirtualNode.getVirtualTreeDB(db).fireNodeGUIChange(node, true);
			}else{
				node.delete();
				ti.realRemove(uid);
				//VirtualNode.getVirtualTreeDB(db).fireNodeGUIChange(node, true);
				VirtualNode.getVirtualTreeDB(db).getDeltaTarget().deleted(uid, true);
			}
		}
		getInstancerMaster(db).getVirtualTreeDB().stopChangeRow();
	}

	@Override
	protected String checkPossibleTarget(TreeNode newtarget) {
		TreeNode master = newtarget.getTreeDB().getNode(getMasterUUId());
		TreeNode par = master.getParent();
		TreeLogic ti = getInstancerMaster(newtarget.getTreeDB()).getTreeDB().getTreeLogic();
		for(TreeNode node:newtarget.getSortedChildren())
			if(!ti.canBeChildOf(node.getType(), par))
				return "'"+par.getUserFriendlyName()+"' cannot be child of '"+node.getUserFriendlyName()+"'";
		return null;
	}

}
