package com.unitesk.requality.eclipse.handlers;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.resources.IProject;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.PlatformUI;


import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.core.TreesTracker;
import com.unitesk.requality.eclipse.natures.ReqCatalogue;
import com.unitesk.requality.nodetypes.InstancesFolder;

public class CreateVersionsFolder extends AbstractHandler {

    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        IStructuredSelection sel = (IStructuredSelection) PlatformUI
                .getWorkbench().getActiveWorkbenchWindow()
                .getSelectionService().getSelection();
        IProject project = (IProject) sel.getFirstElement();
        TreeDB db = TreesTracker.getTracker().getTree(project);
        Object o = null;
		if(db.startTransaction("Create Versions Folder",true)){
			o = createVersionsFolder(db);
			db.commit();
			return o;
		}
		return null;
    }
    public Object createVersionsFolder(TreeDB db){
        TreeNode n = db.getRootNode().createChild("Versions", InstancesFolder.TYPE_NAME);
        return n;
    }
    @Override
    public boolean isEnabled() {
        IStructuredSelection sel = (IStructuredSelection) PlatformUI
                .getWorkbench().getActiveWorkbenchWindow()
                .getSelectionService().getSelection();
        if(sel.getFirstElement() instanceof IProject) {
            IProject project = (IProject) sel.getFirstElement();
            try {
                if(!project.isAccessible())
                    return false;
                if(project.hasNature(ReqCatalogue.ID)) {
                    TreeDB db = TreesTracker.getTracker().getTree(project);
                    return !db.isVirtual() && db.getNode("/Versions")==null;
                }
            } catch (CoreException e) {
                e.printStackTrace();
            }
        }
        return false;
    }

}
