package com.unitesk.requality.eclipse.handlers;

import java.util.List;
import java.util.UUID;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;


import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.ui.cnf.RequalityCNF;
import com.unitesk.requality.nodetypes.VirtualNode;

public class ShowHiddenChildrenForNode extends AbstractHandler {

    @Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        List<TreeNode> nodes = RequalityCNF.getSelectedNodes();
        if(nodes == null || nodes.size() < 1)
            return null;
		try{
			nodes.get(0).getTreeDB().startTransaction("Show hidden elements");
			for(TreeNode node:nodes){
				for(UUID uuid:node.getRawChildrenUUIDs()){
					TreeNode node2 = nodes.get(0).getTreeDB().getNode(uuid);
					if(node2.getType().equals(VirtualNode.TYPE_NAME)){
						((VirtualNode)node2).setHiddenState(false);
						node2.saveAttributes();
						//TODO updatechildren
					}
				}
				node.getTreeDB().updateNodeChildren(node);
			}
			nodes.get(0).getTreeDB().commit();
		}
		catch(Exception e){
			nodes.get(0).getTreeDB().rollback();
    	}
        return null;
    }

    @Override
    public boolean isEnabled() {
        List<TreeNode> nodes = RequalityCNF.getSelectedNodes();
        if (nodes == null) {
            return false;
        }
        for(TreeNode node:nodes){
        	for(UUID uid : node.getRawChildrenUUIDs()){
        		TreeNode nd = node.getTreeDB().getNode(uid);
        		if (nd.getType().equals(VirtualNode.TYPE_NAME)&&((VirtualNode)nd).isHidden())
        			return true;
        	}
        }
        return false;
    }
}
