package com.unitesk.requality.eclipse.handlers.copypaste;

import java.util.ArrayList;
import java.util.List;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.UUID;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.ui.cnf.RequalityCNF;

public class CopyHandler extends AbstractHandler {
	
	@Override
    public Object execute(ExecutionEvent event) throws ExecutionException {
        List<TreeNode> nodes = RequalityCNF.getSelectedNodes();
        copyNodes(nodes.toArray(new TreeNode[0]), false);
        return null;
    }
    public void copyNodes(TreeNode[] nodes, boolean cutNode){
        if(nodes == null)
            return;
        TreeDB db = nodes[0].getTreeDB();
        for(TreeNode tn:nodes){
            if(!tn.getTreeDB().equals(db)
                    ||!db.getTreeLogic().isCopyable(tn))
                return;
        }
        List<TreeNode>workList = new ArrayList<TreeNode>();
        SortedMap<UUID, String> quids 
            = new TreeMap<UUID, String>();
        for(TreeNode node: nodes)
            quids.put(node.getUUId(), node.getQualifiedId());
        for(TreeNode node: nodes){
            boolean add = true;
            for(TreeNode n2:nodes)
                if(n2 != node && quids.get(node.getUUId()).startsWith(
                        quids.get(n2.getUUId())+"/")){
                    add = false;
                    break;
                }
            if(add)
                workList.add(node);
        }
        CopyPasteHelper.getInstance().setNodes(workList);
    }
    
    @Override
	public boolean isEnabled() {
		List<TreeNode> nodes = RequalityCNF.getSelectedNodes();
		if (nodes == null) {
			return false;
		}
		TreeDB db = nodes.get(0).getTreeDB();
		for(TreeNode tn:nodes){
		    if(!tn.getTreeDB().equals(db)
		            ||!db.getTreeLogic().isCopyable(tn))
		        return false;
		}
		return true;
	}
}