package com.unitesk.requality.eclipse.views.atypeeditors;

import org.eclipse.jface.viewers.ICellEditorValidator;
import org.eclipse.jface.viewers.TextCellEditor;
import org.eclipse.swt.widgets.Composite;

public class FloatValueEditor extends TextCellEditor {
	final static ICellEditorValidator validator = new ICellEditorValidator() {
		@Override
		public String isValid(Object value) {
			if(value instanceof Float)
				return null;
			String s = value.toString();
			if(s.startsWith("-"))
				s = s.substring(1);
			try{
				Float.parseFloat(s);
			}catch(NumberFormatException nfe){
				return "Value '"+s+"' cannot be parsed as float";
			}
			return null;
		}
	};
	public FloatValueEditor(Composite parent, int style){
		super(parent, style);
		setValidator(validator);
	}
}
