package com.unitesk.requality.eclipse.views.documents;

import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.Writer;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;
import com.unitesk.requality.eclipse.ui.dialogs.SelectDocDialog;
import com.unitesk.requality.nodetypes.Document;

public abstract class DocumentUpdateProcessor extends DocumentProcessor {

	private TreeDB db;
	private Document oldDocument;
	@Override
	protected boolean process(String docId, Reader reader, Writer writer,
			TreeNode rootNode) throws IOException {
		Reader readerold = null;
		boolean b = false;
		try{
			String htmlName = oldDocument.getResourceName();
			readerold = new InputStreamReader(oldDocument.getResourceContent(htmlName),
                 encoding);
			b = process(oldDocument.getQualifiedId(),docId, readerold, reader, writer, rootNode);
		}
		finally{
			readerold.close();
		}
		return b;
	}
    protected abstract boolean process(String oldDocId, String docId, Reader readerold, Reader reader,
			Writer writer, TreeNode rootNode);
	@Override
    public boolean configure(final Document doc) {
        return configure(doc,null);
    }
	/*
	 * Preferred to call this method, especially in console mode
	 */
	public boolean configure(final Document doc,final Document prefdoc) {
        return configure(doc,prefdoc,false);
    }
	public boolean configure(final Document doc,final Document prefdoc,boolean forcePreffered) {
		this.db = doc.getTreeDB();
        oldDocument = showSelectAnotherDocumentDialog(doc, prefdoc, forcePreffered);
        return oldDocument!=null;
	}
}
