package com.unitesk.requality.eclipse.views.documents;

public class LocationToTransfer implements Comparable<LocationToTransfer> {
	protected LocationPosition location;
	protected double weight;
	protected String spanText;
	
	public LocationPosition getLocation() {
		return location;
	}

	public LocationToTransfer(int start, int end, String text) {
		this.location = new LocationPosition(start, end);
		weight = 1.;
		spanText = text;
	}
	
	public LocationToTransfer(int start, int end, double weight) {
		this.location = new LocationPosition(start, end);
		this.weight = weight;
	}
	
	public double getWeight() {
		return weight;
	}
	
	public void setWeight(double weight) {
		this.weight = weight;
	}
	
	public String getSpanText() {
		return spanText;
	}
	
	@Override
    public int compareTo(final LocationToTransfer o) {
		// sorting in descending order
        return -this.location.compareTo(o.location);
    }
	
}
