package com.unitesk.requality.eclipse.views.documents;

import org.w3c.dom.*;

public class NodeLocation implements Comparable<NodeLocation>{
    
    protected LocationPosition location;
    protected Node node;
    
    public NodeLocation(final LocationPosition location, final Node node) {
        this.location = location;
        this.node = node;
    }

    public LocationPosition getLocation() {
        return location;
    }

    @Override
    public int compareTo(final NodeLocation other) {
        return location.compareTo(other.location);
    }
    
    @Override
    public String toString() {
    	String temp;
    	if (node.getNodeValue() == null) {
    		temp = "-";
    	} else {
    		temp = node.getNodeValue();
    	}
        return location.toString() + " tag:" + node.getNodeName() + " NodeType:" + node.getNodeType() 
        		+ " LocalName:" + node.getLocalName() + " value:<" + temp.replaceAll("\\n", "@").replaceAll("\\r", "~") + ">"; 
    }
    
    public Node getNode() {
        return node;
    }
    
}
