/*
 * Copyright 2011 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package com.unitesk.requality.nodetypes;

import java.util.UUID;

import com.unitesk.requality.core.Attribute;
import com.unitesk.requality.core.AttributeType;

import com.unitesk.requality.core.TreeDB;
import com.unitesk.requality.core.TreeNode;

public class InstancesFolder extends TreeNode {
    public static final String TYPE_NAME = "InstancesFolder";
    public static final String ATTR_DISPLAY_STATUS = "_dstatus";
    
    public InstancesFolder() {
        super(null, null);
    }

    
    public InstancesFolder(TreeDB db, UUID uuid) {
        super(db, uuid);
    }

    @Override
    public String toString() {
        return getId();
    }
    @Override
    public TreeNode findChild(String id) {
    	// TODO Auto-generated method stub
    	return super.findChild(id);
    }

	public int getDisplayStatus() {
		return getIntAttributeValue(InstancesFolder.ATTR_DISPLAY_STATUS, 0);
	}
	
	public void setDisplayStatus(int value)  {
		putAttribute(new Attribute(getUUId(), AttributeType.INT, ATTR_DISPLAY_STATUS, value));
		saveAttributes();
	}
}
